{*******************************************
 *             FuzzyReport 2.0             *
 *                                         *
 *  Copyright (c) 2000 by Fabio Dell'Aria  *
 *                                         *
 *-----------------------------------------*
 * For to use this source code, you must   *
 * read and agree all license conditions.  *
 *******************************************}

unit FR_Const;

interface

{$I FR_Vers.inc}

uses messages;

const
  // Generic consts...
  // -------------------------

  // Numeric consts...
  MoneyToEuro = 1936.27; // Italy euro.
  DefaultUnit = 1; // Italy unit (mm)
  FctStdCnt = 43; // Standard functions count
  PaperCount = 67; // Paper count.
  frSpecCount = 9; // Other values count (N. page / Total page / ...)

  // Alphanumeric consts...
  FRConst_ReportName = 'FuzzyReport';

  FRConst_AssignNameError = 'Non  possibile assegnare un nome gi esistente.';
  FRConst_GeneralError = 'Errore.';
  FRConst_NameError = 'Formato del nome errato.';
  FRConst_ErrorOpenDataSet = 'Non  stato possibile aprire il Dataset:';
  FRConst_DataSetClose = 'Dataset chiuso';
  FRConst_DataSetError = 'Dataset non assegnato';
  FRConst_FilterError = 'Errore nell''espressione del filtro della banda.';
  FRConst_ErrateParentersNum = 'Numero errato di parentesi nell''espressione : ';
  FRConst_UnknownIdentifier = 'Identificatore sconosciuto';
  FRConst_IncompatDataType = 'Tipo di dati incompatibili nell''espressione';
  FRConst_ErrorLoadfrDataSet = 'Non  stato trovato il frDataset:';
  FRConst_Attenction = 'Attenzione';
  FRConst_ErrorInFormat = 'Non  stato possibile terminare la fase' +
    ' di caricamento del report.' + #10#13 +
    'Probabilmente il report  corrotto, o contiene' +
    ' componenti non inseriti all''interno del progetto.';
  FRConst_DirLoadError = 'Si  tentato di caricare il report "%s" da una ' +
    'cartella non valida.' + #13#10 + 'E'' possibile ' +
    'caricare il report solo dalla cartella: ';
  FRConst_NoLoadReport = 'Si  tentato di caricare da disco il report ''%s''. ' +
    #13#10 + 'Ma il file ''%s''  inesistente';
  FRConst_DirSaveError = 'Si  tentato di salvare il report "%s" in una ' +
    'cartella non valida.' + #13#10 + 'E'' possibile ' +
    'salvare il report solo nella cartella: ';
  FRConst_SaveError = 'Si  verificato un errore durante la fase di ' +
    'salvataggio del report';
  FRConst_PreviewCaption = 'Anteprima';
  FRConst_OpenBtnCaption = '&Apri';
  FRConst_OpenBtnHint = 'Apre un report';
  FRConst_SaveBtnCaption = 'Sal&va';
  FRConst_SaveBtnHint = 'Salva il report';
  FRConst_PrintBtnCaption = '&Stampa';
  FRConst_PrintBtnHint = 'Stampa il report';
  FRConst_FindBtnCaption = '&Trova';
  FRConst_FindBtnHint = 'Trova del testo';
  FRConst_ScreenBtnCaption = 'Sc&hermo';
  FRConst_ScreenBtnHint = 'Visualizza l''anteprima a schermo intero';
  FRConst_CloseBtnCaption = '&Chiudi';
  FRConst_CloseBtnHint = 'Chiude il report';
  FRConst_Page = 'Pagina';
  FRConst_PrevBtnHint = 'Pagina precedente';
  FRConst_NextBtnHint = 'Pagina successiva';
  FRConst_ZoomBtnHint = 'Ingrandimento';
  FRConst_ZoomWidth = 'Larghezza';
  FRConst_ZoomOnePage = 'Una pagina';
  FRConst_ZoomTwoPages = 'Due pagine';
  FRConst_OpenDiatogTitle = 'Apre un report.';
  FRConst_OpenDiatogFilter = 'Report files (*.frp)|*.frp';
  FRConst_SaveDiatogTitle = 'Salva il report.';
  FRConst_SaveDiatogFilter = 'Report file (*.frp)|*.frp|Enhanced Meta File' +
    ' - File Grafico (*.emf)|*.emf';
  FRConst_FindTextCaption = 'Trova testo.';
  FRConst_FindLabelCaption = 'Testo da trovare';
  FRConst_FindOptionsCaption = 'Opzioni';
  FRConst_FindCaseCaption = 'Maiuscole/minuscole';
  FRConst_FindSubCaption = 'Parte di una parola';
  FRConst_FindOriginCaption = 'Origine';
  FRConst_FindFirstPageCaption = 'Prima pagina';
  FRConst_FindCurrentPageCaption = 'Pagina corrente';
  FRConst_FindNextCaption = 'Successivo';
  FRConst_FindPreviousCaption = 'Precedente';
  FRConst_OK = '&OK';
  FRConst_Cancel = '&Annulla';
  FRConst_DB = '&Campo DB';
  FRConst_Var = '&Variabile';
  FRConst_Exp = '&Espressione';
  FRConst_FindError = 'Non  stato trovato nessun elemento che ' +
    'soddisfi la richiesta.';
  FRConst_FindTitle = 'Messaggio.';
  FRConst_FormFtlrCaption = 'Esportazione...';
  FRConst_FormFtlrBtnCaption = 'Annulla';
  FRConst_PrmEditCaption = 'Editor di parametri';
  FRConst_AlignFormCaption = 'Allineamento';
  FRConst_AlignFormHint0 = 'Allinea al bordo sinistro';
  FRConst_AlignFormHint1 = 'Allinea orizzontalmente centrando';
  FRConst_AlignFormHint2 = 'Centra orizzontalmente nella finestra';
  FRConst_AlignFormHint3 = 'Spazi uniformi orizzontalmente';
  FRConst_AlignFormHint4 = 'Allinea al bordo destro';
  FRConst_AlignFormHint5 = 'Allinea in alto';
  FRConst_AlignFormHint6 = 'Allinea verticalmente centrando';
  FRConst_AlignFormHint7 = 'Centra verticalmente nella finestra';
  FRConst_AlignFormHint8 = 'Spazi uniformi veticalmente';
  FRConst_AlignFormHint9 = 'Allinea in basso';
  FRConst_BndEdCaption = 'Sorgente di dati della banda';
  FRConst_BndEdLabelCaption1 = 'Sorgente dati';
  FRConst_BndEdLabelCaption2 = 'Inizio';
  FRConst_BndEdLabelCaption3 = 'Fine';
  FRConst_BndEdLabelCaption4 = 'Numero';
  FRConst_BndEdComboBoxItems1 = 'Primo elemento'#13#10'Elemento corrente';
  FRConst_BndEdComboBoxItems2 = 'Ultimo elemento'#13#10'Elemento corrente' +
    #13#10'Elementi contati';
  FRConst_BndEdBitBtnHint = 'Visualizza il nome del frDataset';
  FRConst_BndEdGrpFilterCaption = 'Filtro';
  FRConst_BndEdLabelCaption5 = 'Filtro';
  FRConst_BndEdActiveFiltCaption = 'Attiva il filtro';
  FRConst_NotAssigned = '[Nessuno]';
  FRConst_VirtualDataSet = '[Sorgente dati virtuale]';
  FRConst_NofrDataset = 'Non  stato assegnato nessun frDataset';
  FRConst_frDatasetName = 'Il nome del frDataset corrente :';
  FRConst_Information = 'Informazioni';
  FRConst_BandTypeCaption = 'Inserisci nuova banda';
  FRConst_BandTypeGBCaption = 'Tipo di banda';
  FRConst_CodeBarreCaption = 'Codice a barre';
  FRConst_CodeBarreLabelCaption1 = 'Testo';
  FRConst_CodeBarreLabelCaption2 = 'Tipo di codice';
  FRConst_CodeBarreLabelCaption3 = 'Fattore di scala';
  FRConst_CodeBarreOptiCaption = 'Opzioni';
  FRConst_CodeBarreckCheckCapt = 'Calcola il codice di controllo';
  FRConst_CodeBarreckViewTxtCapt = 'Visualizza il testo';
  FRConst_CodeBarreckShChkTxtCap = 'Visualizza il codice di controllo';
  FRConst_CodeBarreInstall = 'Inserisci codice a barre';
  FRConst_InternalError = '%s: Errore interno';
  FRConst_NumericBarCode = 'Il codice a barre deve essere di tipo numerico';
  FRConst_WrongBarcodeType = '%s: Tipo di codice a barre errato';
  FRConst_InvalidTextlen = 'Lunghezza del testo errata';
  FRConst_CodebadData39 = '%s: Code93 dati errati Data <%s>';
  FRConst_ColorNone = 'Nessuno';
  FRConst_ColorOther = 'Altri ....';
  FRConst_DocOptFormCaption = 'Opzioni report';
  FRConst_DocOptFormGroupBoxCap1 = 'Stampante';
  FRConst_DocOptFormCBCaption = 'Seleziona dove stampare il report';
  FRConst_DocOptFormGroupBoxCap2 = 'Altro';
  FRConst_DocOptFormCBCaption2 = 'Report in due fasi';
  FRConst_DocOptFormCBCaption3 = 'Fascicola report a pagine multiple';
  FRConst_DocOptFormCBCaption4 = 'Reimpagina le pagine fascicolate';
  FRConst_EditorFormCaption = 'Editor di testo';
  FRConst_EditorFormBitBtn1 = '&Formatta';
  FRConst_EditorFormBitBtn2 = 'Evi&denzia';
  FRConst_RichFltFormCaption = 'Esportazione in formato RTF.';
  FRConst_RichFltFrmGroupCaption = 'Opzioni';
  FRConst_RichFltFrmPageBrkCapt = 'Salto pagina';
  FRConst_RichFltFrmKeepLinCapt = 'Elimina interlinee';
  FRConst_RichFltFrmLabelCapt1 = 'Margine sinistro (mm)';
  FRConst_RichFltFrmLabelCapt2 = 'Margine destro (mm)';
  FRConst_RichFltFrmLabelCapt3 = 'Margine superiore (mm)';
  FRConst_RichFltFrmLabelCapt4 = 'Margine inferiore (mm)';
  FRConst_RichFile = 'File RTF - Word compatibile';
  FRConst_TxtFltFrmCaption = 'Esportazione in formato testo.';
  FRConst_TxtFltFrmGroupCaption = 'Opzioni';
  FRConst_TxtFltFrmLabelCapt1 = 'Numero di colonne';
  FRConst_TxtFltFrmPageBrkCapt = 'Salto pagina';
  FRConst_TxtFltFrmTopMargCapt = 'Margine superiore';
  FRConst_TxtFltFrmBotMargCapt = 'Margine inferiore';
  FRConst_TxtFltFrmLeftMargCapt = 'Margine sinistro';
  FRConst_TextFile = 'File di testo ASCII';
  FRConst_EvFrmCaption = 'Editor di variabili';
  FRConst_EvFrmLabelCaption1 = 'Variabili';
  FRConst_EvFrmLabelCaption2 = 'Valore';
  FRConst_EvFrmLabelCaption3 = 'Espressione';
  FRConst_EvFrmNewCategoryHint = 'Nuova categoria';
  FRConst_EvFrmNewvariableHint = 'Nuova variabile';
  FRConst_EvFrmDeleteItemHint = 'Elimina elemento';
  FRConst_EvFrmModifyItemHint = 'Modifica elemento';
  FRConst_SpecVal = 'Altro';
  FRConst_VarName = 'Variabile';
  FRConst_CatName = 'Categoria';
  FRConst_ItemDelete = 'Si desidera eliminare l''elemento selezionato?';
  FRConst_FieldsFormCaption = 'Inserisci campo DB';
  FRConst_FieldsFormLabelCapt1 = 'DB disponibili';
  FRConst_FrmdMemoFrmCaption = 'Editor di testo';
  FRConst_FrmdMemoFrmGroupBoxCap = 'Bordi';
  FRConst_FrmdMemoFrmLabelCap1 = 'Destro';
  FRConst_FrmdMemoFrmLabelCap2 = 'Sinistro';
  FRConst_FrmdMemoFrmLabelCap3 = 'Inferiore';
  FRConst_FrmdMemoFrmLabelCap4 = 'Superiore';
  FRConst_InsFMemo = 'Inserisci rettangolo bordato';
  FRConst_GEditorFormCaption = 'Immagine';
  FRConst_GEditorFormButtonCapt3 = '&Carica...';
  FRConst_GEditorFormButtonCapt4 = '&Svuota';
  FRConst_PictFile = 'File immagine';
  FRConst_AllFiles = 'Tutti i files';
  FRConst_PictOpenFile = 'Carica immagine';
  FRConst_FrGrpEditCaption = 'Opzioni del grafico';
  FRConst_FrGrpEditSlctDSCaption = 'Sorgente dei Dati';
  FRConst_FrGrpEditGNewHint = 'Inserisce un nuovo campo';
  FRConst_FrGrpEditGDelHint = 'Cancella il campo corrente';
  FRConst_FrGrpEditGModHint = 'Modifica il campo corrente';
  FRConst_FrGrpEditLabelCaption1 = 'Titolo delle ascisse';
  FRConst_FrGrpEditLabelCaption2 = 'Titolo delle ordinate';
  FRConst_FrGrpEditLabelCaption3 = 'Titolo del grafico';
  FRConst_FrGrpEditLabelCaption4 = 'Titoli dei campi';
  FRConst_FrGrpEditCheckBoxCapt1 = 'Visualizza la leggenda';
  FRConst_FrGrpEditCheckBoxCapt2 = 'Visualizza il titolo del grafico';
  FRConst_FrGrpEditCheckBoxCapt3 = 'Visualizza il titolo delle ascisse';
  FRConst_FrGrpEditCheckBoxCapt4 = 'Visualizza il titolo delle ordinate';
  FRConst_FrGrpEditOptionsCapt = 'Opzioni';
  FRConst_FrGrpEditComboBoxItms1 = 'Istrogrammi'#13#10'Istogrammi e linee'#13#10 +
    'Triangoli'#13#10'Triangoli e linee'#13#10 +
    'Punti'#13#10'Punti e linee'#13#10'Linee';
  FRConst_FrGrpEditComboBoxItms2 = '[1] - Lire'#13#10'[2] - Euro'#13#10'[3] - ' +
    'Numero (1234,5)'#13#10'[4] - Numero (1234,50)' +
    #13#10'[5] - Numero (1.234,5)'#13#10'[6] - Numero' +
    ' (1.234,50)'#13#10'[7] - Numero (1.234)';
  FRConst_FrGrpEditLabelCaption5 = 'Tipi di grafico';
  FRConst_FrGrpEditLabelCaption6 = 'Formattazione asse delle ordinate';
  FRConst_FrGrpInsGrph = 'Inserisci grafico';
  FRConst_GraphFieldsTitle: array[0..2] of string = ('Valore', 'Colore', 'Legenda');
  FRConst_GrphFldEditCaption = 'Opzioni del campo';
  FRConst_GrphFldEditLabelCapt1 = 'Valore del campo';
  FRConst_GrphFldEditLabelCapt2 = 'Legenda del campo';
  FRConst_GrphFldEditButtonCapt1 = 'Colore del campo';
  FRConst_GroupEditFormCaption = 'Gruppo';
  FRConst_GroupEditFormLabelCap1 = 'Condizione';
  FRConst_HlghtFrmCaption = 'Attributi evidenziatura';
  FRConst_HlghtFrmGroupBoxCapt1 = 'Tipo carattere';
  FRConst_HlghtFrmSpeedBtnCapt1 = 'Colore...';
  FRConst_HlghtFrmCBCaption1 = 'Grassetto';
  FRConst_HlghtFrmCBCaption2 = 'Corsivo';
  FRConst_HlghtFrmCBCaption3 = 'Sottolineato';
  FRConst_HlghtFrmGroupBoxCapt2 = 'Sfondo';
  FRConst_HlghtFrmSpeedBtnCapt2 = 'Colore...';
  FRConst_HlghtFrmRBCaption1 = 'Trasparente';
  FRConst_HlghtFrmRBCaption2 = 'Altro';
  FRConst_HlghtFrmGroupBoxCapt3 = 'Evidenzia';
  FRConst_HlghtFrmLabelCaption2 = 'Condizione';
  FRConst_HlghtFrmCBXCaption1 = 'Usa evidenziatura';
  FRConst_LoadFormCaption = 'Caricamento Report';
  FRConst_LoadFormLabelCaption1 = 'Elenco report disponibili';
  FRConst_TemplFormCaption = 'Nuovo report';
  FRConst_TemplFormGroupBoxCapt1 = 'Descrizione';
  FRConst_OLEFormCaption = 'Oggetto OLE';
  FRConst_OLEFormButtonCaption1 = '&Inserisci';
  FRConst_OLEFormButtonCaption2 = '&Modifica';
  FRConst_OLEFormButtonCaption5 = '&Svuota';
  FRConst_InsOLE = 'Inserisci oggetto OLE';
  FRConst_PgoptFormCaption = 'Opzioni di pagina';
  FRConst_PgoptFormTabSheetCapt1 = 'Foglio';
  FRConst_PgoptFormGroupBoxCapt2 = 'Orientamento';
  FRConst_PgoptFormRBCaption1 = 'Verticale';
  FRConst_PgoptFormRBCaption2 = 'Orizzontale';
  FRConst_PgoptFormGroupBoxCapt3 = 'Misura';
  FRConst_PgoptFormLabelCaption1 = 'Larghezza (mm)';
  FRConst_PgoptFormLabelCaption2 = 'Altezza (mm)';
  FRConst_PgoptFormTabSheetCapt2 = 'Margini';
  FRConst_PgoptFormGroupBoxCapt4 = 'Margini pagina';
  FRConst_PgoptFormLabelCaption3 = 'Sinistro (mm)';
  FRConst_PgoptFormLabelCaption4 = 'Superiore (mm)';
  FRConst_PgoptFormLabelCaption5 = 'Destro (mm)';
  FRConst_PgoptFormLabelCaption6 = 'Inferiore (mm)';
  FRConst_PgoptFormCBCaption5 = 'Non usati';
  FRConst_PgoptFormTabSheetCapt3 = 'Opzioni';
  FRConst_PgoptFormGroupBoxCapt1 = 'Opzioni';
  FRConst_PgoptFormCBCaption1 = 'Stampa alla pagina precedente';
  FRConst_PgoptFormCBCaption2 = 'Intestazione sulla prima pagina';
  FRConst_PgoptFormCBCaption3 = 'Pi di pagina sull''ultima pagina';
  FRConst_PgoptFormCBCaption4 = 'Copia intestazione in tabella';
  FRConst_PgoptFormGroupBoxCapt5 = 'Colonne';
  FRConst_PgoptFormLabelCaption7 = 'Numero';
  FRConst_PgoptFormLabelCaption8 = 'Distanza tra colonne, mm';
  FRConst_PgoptFormTabSheetCapt4 = 'Ingrandimento';
  FRConst_PgoptFormGroupBoxCapt6 = 'Proporzioni';
  FRConst_PgoptFormLabelCaption9 = 'Larghezza pagina';
  FRConst_PgoptFormLabelCapt10 = 'Altezza pagina';
  FRConst_ProgrFilterFormCaption = 'Esportazione...';
  FRConst_RichFormCaption = 'Modifica RichText';
  FRConst_RichFormOpenButtonHint = 'Apri...';
  FRConst_RichFormSaveButtonHint = 'Salva...';
  FRConst_RichFormUndoButtonHint = 'Ripristina';
  FRConst_RichFormBoldButtonHint = 'Grassetto';
  FRConst_RichFormItalicButtHint = 'Corsivo';
  FRConst_RichFormLeftAlignHint = 'Allinea a sinistra';
  FRConst_RichFormCenterAligHint = 'Allinea al centro';
  FRConst_RichFormRightAlignHint = 'Allinea a destra';
  FRConst_RichFormUnderBtnHint = 'Sottolineato';
  FRConst_RichFormBulletsBtnHint = 'Elenco';
  FRConst_RichFormSpeedBtnHint1 = 'Tipo di carattere';
  FRConst_RichFormCancBtnHint = 'Annulla';
  FRConst_RichFormOkBtnHint = 'Chiudi';
  FRConst_RichFormSpeedBtnCapt2 = 'Var';
  FRConst_RichFormSpeedBtnHint2 = 'Inserisci variabile';
  FRConst_RichFormFontNameHint = 'Tipo di carattere';
  FRConst_RichFormEditHint1 = 'Dimensione carattere';
  FRConst_RichFormFontSizeHint = 'Dimensione carattere';
  FRConst_NoCalcEsp = 'Non calcola espressioni';
  FRConst_RTFFile = 'File Rich Text';
  FRConst_InsRichObject = 'Inserisci oggetto RichText';
  FRConst_SaveFormCaption = 'Salvataggio Report';
  FRConst_SaveFormLabelCaption1 = 'Inserire il nome da dare al report';
  FRConst_ShapeEditCaption = 'Tipo di forma';
  FRConst_ShapeEditRBShapeCapt = 'Tipo';
  FRConst_ShapeEditcbTransCapt = 'Trasparente';
  FRConst_ShapeEditRBShapeItems = 'Ellisse'#13#10'Rettangolo'#13#10'Rettangolo' +
    ' arrotondato'#13#10'Linea del primo tipo'#13#10 +
    'Linea del secondo tipo';
  FRConst_InsShape = 'Inserisci forma geometrica';
  FRConst_TemplNewFormCaption = 'Nuovo report da modello';
  FRConst_TemplNewFormLabelCapt1 = 'Commento';
  FRConst_TemplNewFormGrpBoxCap2 = 'Icona';
  FRConst_TemplNewFormButtonCap1 = 'File...';
  FRConst_BMPFile = 'File bitmap';
  FRConst_VarFormCaption = 'Variabili';
  FRConst_VarFormLabelCaption1 = 'Categoria:';
  FRConst_ReportWizardCaption = 'Autocomposizione Report';
  FRConst_ReportWizardLabCapt1 = 'Sorgente dei dati';
  FRConst_ReportWizardLabCapt2 = 'Titolo del report';
  FRConst_ReportWizardSrcLabCap = 'Campi selezionabili';
  FRConst_ReportWizardDstLabCap = 'Campi selezionati';
  FRConst_ReportWizardOptionsCap = 'Foglio';
  FRConst_ReportWizardLandCap = 'Orizzontale';
  FRConst_ReportWizardPortCap = 'Verticale';
  FRConst_FmtFormCaption = 'Formatta variabile';
  FRConst_FmtFormGroupBoxCapt2 = 'Formato variabile';
  FRConst_FmtFormLabelCaption5 = 'Cifre decimali';
  FRConst_FmtFormLabelCaption6 = 'Simbolo frazione';
  FRConst_FmtFormLabelCaption1 = 'Formato';
  FRConst_Categ: array[1..5] of string = ('Testo', 'Numero', 'Data', 'Orario', 'Logico');
  FRConst_Format: array[1..5, 1..5] of string = (('[Nessuno]', '', '', '', ''),
    ('1234,5', '1234,50', '1.234,5',
    '1.234,50', 'Personalizzato'),
    ('05/11/98', '05/11/1998',
    '5 nov 1998', '5 novembre 1998',
    'Personalizzato'),
    ('02:43:35', '2:43:35', '02:43',
    '2:43', 'Personalizzato'),
    ('0/1', 'Si/No', 'X/_', '', ''));
  FRConst_ReportConvert = 'Converti il report';
  FRConst_ConvLimit = 'Bisogna posizionare questo componente sul form' +
    ' contenente i QuickReport che si desiderano convertire.';
  FRConst_ConvControlName = 'Il controllo di nome ''';
  FRConst_ConvNoDataSet = ''' non ha assegnato nessun DataSet.';
  FRConst_RepNoName = 'Nessun nome';
  FRConst_DesignReport = 'Disegna report';
  FRConst_PreviewReport = 'Anteprima report';
  FRConst_NewReport = 'Nuovo report';
  FRConst_NewFromTemplate = 'Nuovo da modello...';
  FRConst_OpenReport = 'Apri report...';
  FRConst_VarEditor = 'Editor di variabili...';
  FRConst_FormFile = FRConst_ReportName + ' form';
  FRConst_DefaultPrinter = 'Stampante predefinita';
  FRConst_Paper: array[0..66] of string = ('Personalizzato',
    'Lettera, 8 1/2 x 11"',
    'Lettera piccola, 8 1/2 x 11"',
    'Compresso, 11 x 17"',
    'Libro mastro, 17 x 11"',
    'Legale, 8 1/2 x 14"',
    'Dichiarazione, 5 1/2 x 8 1/2"',
    'Esecutivo, 7 1/4 x 10 1/2"',
    'A3 297 x 420 mm',
    'A4 210 x 297 mm',
    'A4 foglio piccolo, 210 x 297 mm',
    'A5 148 x 210 mm',
    'B4 250 x 354 mm',
    'B5 182 x 257 mm',
    'Foglio, 8 1/2 x 13"',
    'Foglio quarto, 215 x 275 mm',
    'Foglio 10 x 14"',
    'Foglio 11 x 17"',
    'Note, 8 1/2 x 11"',
    '9 Busta, 3 7/8 x 8 7/8"',
    '#10 Busta, 4 1/8  x 9 1/2"',
    '#11 Busta, 4 1/2 x 10 3/8"',
    '#12 Busta, 4 3/4 x 11"',
    '#14 Busta, 5 x 11 1/2"',
    'C Foglio, 17 x 22"',
    'D Foglio, 22 x 34"',
    'E Foglio, 34 x 44"',
    'DL Busta, 110 x 220 mm',
    'C5 Busta, 162 x 229 mm',
    'C3 Busta,  324 x 458 mm',
    'C4 Busta,  229 x 324 mm',
    'C6 Busta,  114 x 162 mm',
    'C65 Busta, 114 x 229 mm',
    'B4 Busta,  250 x 353 mm',
    'B5 Busta,  176 x 250 mm',
    'B6 Busta,  176 x 125 mm',
    'Busta italiana, 110 x 230 mm',
    'Busta re, 3 7/8 x 7 1/2"',
    '6 3/4 Busta, 3 5/8 x 6 1/2"',
    'Standard Fanfold americano, 14 7/8 x 11"',
    'Standard Fanfold tedesco, 8 1/2 x 12"',
    'Legale Fanfold tedesco, 8 1/2 x 13"',
    'B4 (ISO) 250 x 353 mm',
    'Cartolina giapponese 100 x 148 mm',
    'Foglio 9 x 11"',
    'Foglio 10 x 11"',
    'Foglio 15 x 11"',
    'Busta Invito 220 x 220 mm',
    'Lettera Extra 9 \ 275 x 12"',
    'Legale Extra 9 \275 x 15"',
    'Compresso Extra 11.69 x 18"',
    'A4 Extra 9.27 x 12.69"',
    'Lettera Trasversale 8 \275 x 11"',
    'A4 Transversale 210 x 297 mm',
    'Lettera Extra Trasversale 9\275 x 12"',
    'SuperASuperAA4 227 x 356 mm',
    'SuperBSuperBA3 305 x 487 mm',
    'Lettera Plus 8.5 x 12.69"',
    'A4 Plus 210 x 330 mm',
    'A5 Trasversale 148 x 210 mm',
    'B5 (JIS) Trasversale 182 x 257 mm',
    'A3 Extra 322 x 445 mm',
    'A5 Extra 174 x 235 mm',
    'B5 (ISO) Extra 201 x 276 mm',
    'A2 420 x 594 mm',
    'A3 Trasversale 297 x 420 mm',
    'A3 Extra Trasversale 322 x 445 mm');
  FRConst_ErrorOccured = 'Si  verificato un errore durante la fase ' +
    'di preparazione';
  FRConst_Object = 'Oggetto';
  FRConst_Band = 'Banda:';
  FRConst_Pg = 'Pagina';
  FRConst_ClassNoFound = 'Oggetto non trovato : %s.' + #10#13 +
    'Un componente avanzato presente nel report, ' + #10#13 +
    'non  stato inserito nel programma che ne fa uso.';
  FRConst_Error = 'Errore';
  FRConst_Stretched = 'Adattato';
  FRConst_ExprHighlightError = 'Espressione per il calcolo dell''evidenziatura errata';
  FRConst_VarFormat = 'Formatta variabile...';
  FRConst_WordWrap = 'A capo';
  FRConst_AutoSize = 'Largezza automatica';
  FRConst_FormNewPage = 'Forza pagina nuova';
  FRConst_PrintIfSubsetEmpty = 'Stampa se i dettagli sono vuoti';
  FRConst_Breaked = 'Banda interrotta';
  FRConst_CompleteList = 'Completa l''elenco';
  FRConst_SubReportOnPage = 'SottoReport in pagina';
  FRConst_Picture = '[Immagine]';
  FRConst_InvalidImageFormat = 'Formato immagine sconosciuto.';
  FRConst_PictureCenter = 'Centra immagine';
  FRConst_KeepAspectRatio = 'Mantieni le proporzioni';
  FRConst_From = 'di';
  FRConst_Zero = 'zero';
  FRConst_Hundred = 'cento';
  FRConst_Point = 'virgola';
  FRConst_Negative = 'meno';
  FRConst_InvalideParameters = 'Formato parametri non valido nella funzione ';
  FRConst_FailAggregation = 'Non  possibile inserire in una banda non ' +
    'abilitata la funzione statistica ';
  FRConst_ErrorParamNumber = 'E'' stato inserito un numero di parametri ' +
    'errato per la funzione ';
  FRConst_FunctPrmError = 'Tipi di parametri errati nella funzione';
  FRConst_Yes = 'Si';
  FRConst_No = 'No';
  FRConst_ReportPreparing = 'Report in preparazione';
  FRConst_FirstPass = 'Esecuzione 1 passo:';
  FRConst_PagePreparing = 'Pagina in costruzione:';
  FRConst_Preview = 'Anteprima';
  FRConst_PagePrinting = 'Pagina in stampa:';
  FRConst_PrinterError = 'La stampante selezionata non  valida';
  FRConst_ErrorFindField = 'Non  stato possibile reperire il campo:';
  FRConst_ObjectNotFound = 'Non  stato trovato nel report l''oggetto';
  FRConst_BandNoFound = 'Non  stata trovata la banda:';
  FRConst_NoAssignNoBand = 'Non si pu collegare un frDataset ad un ' +
    'oggetto che non sia una banda.';
  FRConst_Value = 'Valore';
  FRConst_Bands: array[0..21] of string = ('Titolo report',
    'Pi di pagina report',
    'Instestazione pagina',
    'Pi di pagina',
    'Intestazione principale',
    'Dati principali',
    'Pi di pagina principale',
    'Intestazione dettagli',
    'Dati dettagli',
    'Pi di pagina dettagli',
    'Intestazione sottodettagli',
    'Dati sottodettagli',
    'Pi di pagina sottodettagli',
    'Copertura (Sfondo)',
    'Intestazione colonna',
    'Pi di pagina colonna',
    'Intestazione gruppo',
    'Pi di pagina gruppo',
    'Intestazione Tabella',
    'Dati Tabella',
    'Pi di pagina Tabella',
    'Nessuna');
  FRConst_Vars: array[0..frSpecCount - 1] of string = ('N pagina', 'Espressione',
    'Data', 'Ora', 'N linea',
    'N linea continuo',
    'N colonna', 'N linea corrente',
    'Totale Pagine');
  FRConst_Number1: array[0..19] of string = ('', 'uno', 'due', 'tre', 'quattro',
    'cinque', 'sei', 'sette', 'otto',
    'nove', 'dieci', 'undici', 'dodici',
    'tredici', 'quattordici', 'quindici',
    'sedici', 'diciassette', 'diciotto',
    'diciannove');
  FRConst_Number2: array[0..9] of string = ('', '', 'venti', 'trenta', 'quaranta',
    'cinquanta', 'sessanta', 'settanta',
    'ottanta', 'novanta');
  FRConst_Number3: array[0..9] of string = ('mille', 'mila', 'unmilione',
    'milioni', 'unmiliardo', 'miliardi',
    'millemiliardi', 'miliardi',
    'unmilionedimiliardi', 'milionidimiliardi');
  FRConst_CatAll = 'Tutte';
  FRConst_CatInconnue = 'Sconosciute';
  FRConst_Functions: array[1..FctStdCnt] of string =
  ('AVG=Statistiche |AVG(<X>) |Restituiosce la media della serie <X>',
    'COUNT=Statistiche |COUNT() |Restituisce il numero di elementi della serie',
    'FORMATDATETIME=Conversione |FORMATDATETIME(<X>,<Y>) |Restituisce la data <Y> con il formato <X>',
    'FORMATFLOAT=Conversione |FORMATFLOAT(<X>,<Y>) |Restituisce il numero <Y> con il formato <X>',
    'LOWERCASE=Stringa |LOWERCASE(<X>) |Restituisce <X> in minuscolo',
    'MAX=Statistiche |MAX(<X>) |Restituisce il valore minimo della serie <X>',
    'MIN=Statistiche |MIN(<X>) |Restituisce il valore massimo della serie <X>',
    'NAMECASE=Stringa |NAMECASE(<X>) |Restituisce <X> in minuscolo eccetto che per il primo carattere in maiuscolo',
    'PHRASECASE=Stringa |PHRASECASE(<X>) |Restituisce <X> in minuscolo eccetto che per le iniziali di ogni parola contenuta nel testo',
    'STRTODATE=Conversione |STRTODATE(<X>) |Restituisce la data contenuta nella stringa <X>',
    'STRTOTIME=Conversione |STRTOTIME(<X>) |Restituisce l''orario contenuto nella stringa <X>',
    'SUM=Statistiche |SUM(<X>) |Restituisce la somma della serie <X>',
    'UPPERCASE=Stringa |UPPERCASE(<X>) |Restituisce <X> in maiuscolo',
    'NUMBERTOLETTER=Stringa |NUMBERTOLETTER(<X>) |Restituisce l''equivalente in lettere del numero <X>',
    'INT=Matematiche |INT(<X>) |Restituisce la parte intera del numero <X>',
    'FRAC=Matematiche |FRAC(<X>) |Resituisce la parte decimale del numero <X>',
    'ROUND=Matematiche |ROUND(<X>) |Restituisce il numero intero corrispondente all''arrotondamento si <X>',
    'STR=Stringa |STR(<X>) |Restituisce una stringa convertita dal numero <X>',
    'COPY=Stringa |COPY(<X>,<Y>,<Z>) |Restituisce una sotto-stringa copiata dalla stringa <X> a partire dalla posizione <Y> per <Z> caratteri',
    'IF=Logiche |IF(<X>,<Y>,<Z>) |Restituisce <Y> se l''espressione <X>  verificata altrimenti restituisce <Z>',
    'TRUNC=Matematiche |TRUNC(<X>) |Restituisce il numero intero corrispondente al troncamento di <X>',
    'ABS=Matematiche |ABS(<X>) |Restituisce il valore assoluto di <X>',
    'ARCTAN=Matematiche |ARCTAN(<X>) |Restituisce l''arcotangente di <X>',
    'COS=Matematiche |COS(<X>) |Restituisce il coseno di <X>',
    'EXP=Matematiche |EXP(<X>) |Restituisce l''esponenziale di <X>',
    'LN=Matematiche |LN(<X>) |Restituisce il logaritmo naturale di <X>',
    'PI=Matematiche |PI |Restituisce il valore di pigreco',
    'SIN=Matematiche |SIN(<X>) |Restituisce il seno di <X>',
    'SQR=Matematiche |SQR(<X>) |Restituisce il quadrato di <X>',
    'SQRT=Matematiche |SQRT(<X>) |Restituisce la radice quadrata di <X>',
    'POWER=Matematiche |POWER(<X>,<Y>) |Restituisce il numero equivalente a <X> elevato ad <Y>',
    'CEIL=Matematiche |CEIL(<X>) |Restituisce il numero intero corrispondente all''arrotondamento per eccesso di <X>',
    'FLOOR=Matematiche |FLOOR(<X>) |Restituisce il numero intero corrispondente all''arrotondamento per difetto di <X>',
    'POS=Stringa |POS(<X>,<Y>) |Restituisce il numero corrispondente alla posizione della sottostringa <X> nella stringa <Y>',
    'LENGTH=Stringa |LENGTH(<X>) |Restituisce la lunghezza della stringa <X>',
    'FILLSTR=Stringa |FILLSTR(<X>,<Y>) |Restituisce una stringa formata da un numero <X> di stringhe <Y>',
    'VAL=Matematiche |VAL(<X>) |Restituisce la conversione numerica di <X>',
    'MONEY=Valuta |MONEY(<X>) |Restituisce una stringa contenente il numero <X> formattato come valuta nel sistema corrente',
    'EURO=Valuta |EURO(<X>) |Restituisce una stringa contenente il numero <X> formattato come euro',
    'MONEYTOEURO=Valuta |MONEYTOEURO(<X>) |Restituisce una stringa contenente il numero <X> convertito dalla moneta corrente in euro e formattato',
    'EUROTOMONEY=Valuta |EUROTOMONEY(<X>) |Restituisce una stringa contenente il numero <X> convertito da euro alla moneta corrente e formattato',
    'MONEYTOEUROVAL=Valuta |MONEYTOEUROVAL(<X>) |Restituisce il numero <X> convertito dalla moneta corrente in euro',
    'EUROTOMONEYVAL=Valuta |EUROTOMONEYVAL(<X>) |Restituisce il numero <X> convertito da euro alla moneta corrente');
  FRConst_InspFormCaption = 'Controllo oggetto';
  FRConst_ExpresEditorCaption = 'Editor di espressioni';
  FRConst_ExpresEditorGB1Caption = 'Costanti';
  FRConst_ExpresEditorBB1Caption = 'Aggiungi';
  FRConst_ExpresEditorGB2Caption = 'Operatori';
  FRConst_ExpresEditorBUndoCapt = 'Ripristina';
  FRConst_ExpresEditorBB3Caption = 'Elimina';
  FRConst_ExpresEditorGB3Caption = 'Funzioni';
  FRConst_ExpresEditorBaddFctCap = 'Aggiungi';
  FRConst_ExpresEditorGB4Caption = 'Dati';
  FRConst_ExpresEditorBB7Caption = 'Aggiungi';
  FRConst_ExpresEditorRbItems1 = 'Variabili';
  FRConst_ExpresEditorRbItems2 = 'Dati';
  FRConst_ExpresEditorTbTabs1 = 'Matematici';
  FRConst_ExpresEditorTbTabs2 = 'Logici';
  FRConst_ExpresEditorCbCItems1 = 'Testo';
  FRConst_ExpresEditorCbCItems2 = 'Numerica';
  FRConst_DsgFrm_Caption = 'Modellatore';
  FRConst_DsgFrm_FileBtn1Hint = 'Nuovo report';
  FRConst_DsgFrm_FileBtn2Hint = 'Apri report';
  FRConst_DsgFrm_FileBtn3Hint = 'Salva report';
  FRConst_DsgFrm_FileBtn4Hint = 'Anteprima report';
  FRConst_DsgFrm_CutBHint = 'Taglia';
  FRConst_DsgFrm_CopyBHint = 'Copia';
  FRConst_DsgFrm_PstBHint = 'Incolla';
  FRConst_DsgFrm_BtnPrevHint = 'Annulla';
  FRConst_DsgFrm_BtnNextHint = 'Ripristina';
  FRConst_DsgFrm_ZB1Hint = 'Porta in primo piano';
  FRConst_DsgFrm_ZB2Hint = 'Porta in secondo piano';
  FRConst_DsgFrm_SelAllBHint = 'Seleziona tutto';
  FRConst_DsgFrm_PgB1Hint = 'Aggiungi pagina';
  FRConst_DsgFrm_PgB2Hint = 'Rimuovi pagina';
  FRConst_DsgFrm_PgB3Hint = 'Opzioni pagina';
  FRConst_DsgFrm_PgB4Hint = 'Gestione pagine';
  FRConst_DsgFrm_GB2Hint = 'Allinea alla griglia';
  FRConst_DsgFrm_ExitBCaption = 'Chiudi';
  FRConst_DsgFrm_ExitBHint = 'Chiudi modellatore';
  FRConst_DsgFrm_AlB1Hint = 'Allinea a sinistra';
  FRConst_DsgFrm_AlB2Hint = 'Allinea a destra';
  FRConst_DsgFrm_AlB3Hint = 'Centra';
  FRConst_DsgFrm_AlB8Hint = 'Giustifica tutto il testo';
  FRConst_DsgFrm_AlB5Hint = 'Centra in verticale';
  FRConst_DsgFrm_AlB6Hint = 'Allinea in alto';
  FRConst_DsgFrm_AlB7Hint = 'Allinea in basso';
  FRConst_DsgFrm_AlB4Hint = 'Testo normale / 90 gradi';
  FRConst_DsgFrm_FnB1Hint = 'Grassetto';
  FRConst_DsgFrm_FnB2Hint = 'Corsivo';
  FRConst_DsgFrm_FnB3Hint = 'Sottolineato';
  FRConst_DsgFrm_ClB2Hint = 'Colore carattere';
  FRConst_DsgFrm_C3Hint = 'Dimenzione carattere';
  FRConst_DsgFrm_C2Hint = 'Nome tipo di carattere';
  FRConst_DsgFrm_HlB1Hint = 'Attributi evidenziatura';
  FRConst_DsgFrm_FrB1Hint = 'Linea bordo superiore';
  FRConst_DsgFrm_FrB2Hint = 'Linea bordo sinistro';
  FRConst_DsgFrm_FrB3Hint = 'Linea bordo inferiore';
  FRConst_DsgFrm_FrB4Hint = 'Linea bordo destra';
  FRConst_DsgFrm_FrB5Hint = 'Tutto il bordo';
  FRConst_DsgFrm_FrB6Hint = 'Nessun bordo';
  FRConst_DsgFrm_ClB1Hint = 'Colore sfondo';
  FRConst_DsgFrm_ClB3Hint = 'Colore bordo';
  FRConst_DsgFrm_Edit1Hint = 'Larghezza bordo';
  FRConst_DsgFrm_UpDown1Hint = 'Larghezza bordo';
  FRConst_DsgFrm_OB1Hint = 'Seleziona oggetto';
  FRConst_DsgFrm_OB2Hint = 'Inserisci rettangolo';
  FRConst_DsgFrm_OB3Hint = 'Inserisci banda';
  FRConst_DsgFrm_OB4Hint = 'Inserisci immagine';
  FRConst_DsgFrm_OB5Hint = 'Inserisci sottoreport';
  FRConst_DsgFrm_Wiz1Caption = 'Nuovo da autocomposizione...';
  FRConst_DsgFrm_N2Caption = 'Taglia';
  FRConst_DsgFrm_N1Caption = 'Copia';
  FRConst_DsgFrm_N3Caption = 'Incolla';
  FRConst_DsgFrm_N5Caption = 'Elimina';
  FRConst_DsgFrm_N16Caption = 'Seleziona tutto';
  FRConst_DsgFrm_N6Caption = 'Modifica...';
  FRConst_DsgFrm_N4Caption = '&File';
  FRConst_DsgFrm_N23Caption = 'Nuovo da modello...';
  FRConst_DsgFrm_N19Caption = 'Apri...';
  FRConst_DsgFrm_N15Caption = 'Salva con nome...';
  FRConst_DsgFrm_N20Caption = 'Salva';
  FRConst_DsgFrm_N42Caption = 'Lista variabili...';
  FRConst_DsgFrm_N8Caption = 'Opzioni report...';
  FRConst_DsgFrm_N25Caption = 'Opzioni pagina...';
  FRConst_DsgFrm_N39Caption = 'Anteprima';
  FRConst_DsgFrm_N10Caption = 'Esci';
  FRConst_DsgFrm_N7Caption = '&Modifica';
  FRConst_DsgFrm_UndoCaption = 'Annulla';
  FRConst_DsgFrm_RestoreCaption = 'Ripristina';
  FRConst_DsgFrm_N11Caption = 'Taglia';
  FRConst_DsgFrm_N12Caption = 'Copia';
  FRConst_DsgFrm_N13Caption = 'Incolla';
  FRConst_DsgFrm_N27Caption = 'Cancella';
  FRConst_DsgFrm_N28Caption = 'Selziona tutto';
  FRConst_DsgFrm_N36Caption = 'Modifica...';
  FRConst_DsgFrm_N29Caption = 'Aggiungi pagina';
  FRConst_DsgFrm_N30Caption = 'Rimuovi pagina';
  FRConst_DsgFrm_N32Caption = 'Porta in primo piano';
  FRConst_DsgFrm_N33Caption = 'Porta in secondo piano';
  FRConst_DsgFrm_N9Caption = '&Strumenti';
  FRConst_DsgFrm_N14Caption = 'Griglia';
  FRConst_DsgFrm_Gr2Caption = 'Allinea alla griglia';
  FRConst_DsgFrm_Gr3Caption = '4 punti (circa 1 mm)';
  FRConst_DsgFrm_Gr4Caption = '8 punti (circa 2 mm)';
  FRConst_DsgFrm_Gr5Caption = '19 punti (circa 5 mm)';
  FRConst_DsgFrm_N18Caption = 'Selezione';
  FRConst_DsgFrm_N22Caption = 'Bordo';
  FRConst_DsgFrm_N35Caption = 'Inverti';
  FRConst_DsgFrm_N37Caption = 'Barra degli strumenti';
  FRConst_DsgFrm_Pan1Caption = 'Predefinito';
  FRConst_DsgFrm_Pan2Caption = 'Testo';
  FRConst_DsgFrm_Pan3Caption = 'Rettangolo';
  FRConst_DsgFrm_Pan4Caption = 'Oggetti';
  FRConst_DsgFrm_Pan5Caption = 'Controllo Oggetto';
  FRConst_DsgFrm_Pan6Caption = 'Strumenti di allineamento';
  FRConst_DsgFrm_MastMenuCaption = 'Unit di misura';
  FRConst_DsgFrm_M1Caption = 'Punti';
  FRConst_DsgFrm_M2Caption = 'Millimetri';
  FRConst_DsgFrm_M3Caption = 'Pollici';
  FRConst_DsgFrm_ReOpMenu = '&Riapri';
  FRConst_Name = 'Nome';
  FRConst_Left = 'X';
  FRConst_Top = 'Y';
  FRConst_Width = 'Larghezza';
  FRConst_Height = 'Altezza';
  FRConst_Memo = 'Testo';
  FRConst_Visible = 'Visibile';
  FRConst_True = 'Vero';
  FRConst_False = 'Falso';
  FRConst_RemovePg = 'Rimuovere questa pagina?';
  FRConst_Confirm = 'Conferma';
  FRConst_FileOverWrite = 'Esiste gi un report con questo nome.' + #13#10 +
    'Si desidera sovrascriverlo?';
  FRConst_MessageNewBlank = 'Si desidera salvare i cambiamenti al report corrente?';
  FRConst_MessageNew = 'Si desidera salvare i cambiamenti a';
  FRConst_PropertyError = 'Il valore inserito non  valido.';
  FRConst_TemplFile = 'Modello ' + FRConst_ReportName;
  FRConst_FrmSelRepCaption = 'Elenco dei report convertibili';
  FRConst_FrmSelRepTitle = 'Selezionare i report da convertire';
  FRConst_PagesListCaption = 'Gestione pagine';
  FRConst_PagesListLabelCaption = 'Elenco pagine';

implementation

end.

