unit FR_SelQR;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, CheckLst, ComCtrls, FR_Const;

type
  TfrmSelReport = class(TForm)
    ReportList: TListView;
    LabelSelReport: TLabel;
    OK: TBitBtn;
    Cancel: TBitBtn;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure SetElenco(Value: TStringList);
  public
    { Public declarations }
    property Elenco: TStringList write SetElenco;

    procedure AggiornaElenco(var sElencoReport, sElencoID: TStringList);
  end;

var
  frmSelReport: TfrmSelReport;

implementation

{$R *.DFM}

procedure TfrmSelReport.SetElenco(Value: TStringList);
var
  It: TListItem;
  I: Integer;
begin
  { Copia l'elenco nella ListView}
  ReportList.Items.Clear;
  for I := 0 to Value.Count - 1 do
    begin
      It := ReportList.Items.Add;
      It.Caption := Value[I];
    end;
end;

procedure TfrmSelReport.AggiornaElenco(var sElencoReport, sElencoID: TStringList);
var
  I: Integer;
begin
  with ReportList do
    begin
      { Scorre gli elementi della ListBox }
      for I := Items.Count - 1 downto 0 do
        begin
          { Ogni volta che trova un elemento non selezionato lo elimina dalle
            liste passate tramite i due parametri }
          if not Items[I].Checked then
            begin
              sElencoReport.Delete(I);
              sElencoID.Delete(I);
            end;
        end;
    end;
end;

procedure TfrmSelReport.FormCreate(Sender: TObject);
begin
  Caption := FRConst_FrmSelRepCaption;
  LabelSelReport.Caption := FRConst_FrmSelRepTitle;
  OK.Caption := FRConst_OK;
  Cancel.Caption := FRConst_Cancel;
end;

end.

